<template>
    <v-dialog :value="value" @input="$emit('input')" scrollable max-width="500px">
        <v-card>
        <v-card-text>
            <div class="box">
                <st-title text="Datos del tutor"/>
                <st-alert
                    v-if="alert.type"
                    :text="alert.text"
                    :type="alert.type"
                />
                <v-form
                    ref="form"
                    v-model="valid"
                >
                <div class="fields">
                <v-text-field
                    v-for="(field, index) in fields"
                    v-model="field.value"
                    :counter="field.counter"
                    :rules="field.rules"
                    :label="field.label"
                    :key="index"
                    required
                />
                </div>
                <div class="content-footer">
                <st-secondary-btn nombre="Cancelar" @click="$emit('input')"/>
                <st-primary-btn
                    nombre = "Registrar tutor"
                    @click="validate"
                    :disable="!valid"
                    :loading="loading"
                />

                </div>
                </v-form>
            </div>
        </v-card-text>
        </v-card>
    </v-dialog>
</template>

<script>
export default {
    props:['value'],


    data(){
        return{
            valid: false,
            newTutor: false,
            loading:false,
            alert:{
                text:'',
                type:''
            },
            fields:{
                correo:{
                    value: '',
                    label: 'Correo electrónico',
                    counter: '',
                    rules: [
                        v => !!v || 'El e-mail es requerido',
                        v => /.+@.+\..+/.test(v) || 'El correo debe ser valido',
                    ],
                },
                codigo:{
                    value: '',
                    label: 'Código del tutor',
                    counter: '8',
                    rules: [
                        v => !!v || 'El codigo es requerido',
                    ],
                },
                nombres:{
                    value: '',
                    label: 'Nombres',
                    counter: '150',
                    rules: [
                        v => !!v || 'El nombre es requerido',
                        v => (v && v.length <= 150) || 'El nombre debe tener menos de 10 caracteres.',
                    ],
                },
                apellidoPat:{
                    value: '',
                    label: 'Apellido paterno',
                    counter: '150',
                    rules: [
                        v => !!v || 'El apellido paterno es requerido',
                    ],
                },
                apellidoMat:{
                    value: '',
                    label: 'Apellido materno',
                    counter: '150',
                    rules: [
                        v => !!v || 'El apellido materno es requerido',
                    ],
                },
                telefono:{
                    value: '',
                    label: 'Teléfono',
                    counter: '9',
                    rules: [],
                }
            }//acaba fields
        }//acaba return

    },//acaba data
    methods:{

        async registerTutor(data){
            this.loading=true
            try{
                let response = await this.$api.addTutor(data)
                this.$emit('refreshData',{ response: response})
            } catch(e){
                this.$store.commit('setError', e)
            }
            this.loading=false

        },

        validate(){
            const idUnit = this.$store.state.role.idUnit;
            let field=this.fields
            let data = {
                'data': {
                    "idUnidad": idUnit,
                    "tutor":{
                      "correo": field.correo.value,
                      "codigo": field.codigo.value,
                      "nombres": field.nombres.value,
                      "apellidoPat": field.apellidoPat.value,
                      "apellidoMat": field.apellidoMat.value,
                      "telefono": field.telefono.value
      			        }
                }
            }
            this.registerTutor(data)

        },
    }
}


</script>

<style scoped lang="scss">
.v-card__text{
  padding:0 !important
}
</style>
